/*
 * Copyright (c) 2001 Michael David Adams.
 * All rights reserved.
 *
 * The complete licensing terms for this software can be found in the file
 * named "LICENSE" in this software distribution.
 */

/*
 * Tag/Value Parser
 *
 * $Id$
 */

#ifndef TVPARSER_H
#define TVPARSER_H

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
	int id;
	char *name;
} taginfo_t;

typedef struct {
	char *buf;
	char *tag;
	char *val;
	char *pos;
} tvparser_t;

taginfo_t *taginfos_lookup(taginfo_t *taginfos, const char *name);
taginfo_t *taginfo_nonull(taginfo_t *taginfo);

tvparser_t *tvparser_create(const char *s);
int tvparser_next(tvparser_t *tvparser);
char *tvparser_gettag(tvparser_t *tvparser);
char *tvparser_getval(tvparser_t *tvparser);
void tvparser_destroy(tvparser_t *tvparser);

#ifdef __cplusplus
}
#endif

#endif
