/*
 * Copyright (c) 1999-2000 Image Power, Inc. and the University of
 *   British Columbia.
 * Copyright (c) 2001 Michael David Adams.
 * All rights reserved.
 *
 * The complete licensing terms for this software can be found in the file
 * named "LICENSE" in this software distribution.
 */

/*
 * $Id$
 */

#ifndef JPCCOD_H
#define JPCCOD_H

/******************************************************************************\
* Includes.
\******************************************************************************/

#include "mqcod.h"
#include "stream.h"
#include "image.h"
#include "fix.h"
#include "tsfb.h"

/******************************************************************************\
* Constants.
\******************************************************************************/

#define	JPC_MAXRLVLS	33
#define	JPC_MAXBANDS	(3 * JPC_MAXRLVLS + 1)

#define	FMT_UNSIGNED	0
#define	FMT_SIGNED	1

#define JP_LL	0
#define JP_LH	1
#define JP_HL	2
#define JP_HH	3

#define	PREC	32

/******************************************************************************\
* Types.
\******************************************************************************/

/******************************************************************************\
* Functions and macros.
\******************************************************************************/

tsfb_t *cod_gettsfb(int qmfbid, int numlevels);

#define	NOMRANGEBITS(fmt, prec) \
	(((fmt) == FMT_UNSIGNED) ? ((prec) - 1) : (prec))

#define	ASR(x, n) \
	(((n) >= 0) ? ((x) >> (n)) : ((x) << (-(n))))

#endif
