/*
 * Copyright (c) 1999-2000 Image Power, Inc. and the University of
 *   British Columbia.
 * Copyright (c) 2001 Michael David Adams.
 * All rights reserved.
 *
 * The complete licensing terms for this software can be found in the file
 * named "LICENSE" in this software distribution.
 */

/*
 * Tier 1 Encoder
 *
 * $Id$
 */

#ifndef T1ENC_H
#define T1ENC_H

/******************************************************************************\
* Includes.
\******************************************************************************/

#include "jpcenc.h"
#include "seq.h"
#include "t1cod.h"

/******************************************************************************\
* Functions.
\******************************************************************************/

int enc_enccblks(enc_t *enc);
int enc_enccblk(enc_t *enc, stream_t *out, enc_tcmpt_t *comp, enc_band_t *band, enc_cblk_t *cblk);
int enc_sigpass(mqenc_t *mqenc, int bitpos, int orient, int, matrix_t *flags,
  matrix_t *data, int term, long *nmsedec);
int enc_refpass(mqenc_t *mqenc, int bitpos, int, matrix_t *flags, matrix_t *data,
  int term, long *nmsedec);
int enc_clnpass(mqenc_t *mqenc, int bitpos, int orient, int, int, matrix_t *flags,
  matrix_t *data, int term, long *nmsedec);

int enc_rawsigpass(bitstream_t *out, int bitpos, int, matrix_t *flags,
  matrix_t *data, int term, long *nmsedec);
int enc_rawrefpass(bitstream_t *out, int bitpos, int, matrix_t *flags,
  matrix_t *data, int term, long *nmsedec);

#endif
